﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Ball : MonoBehaviour
{

    // config parameters
    [SerializeField] Paddle paddle1;  //link to appropriate paddle in editor
    [SerializeField] float launchVelocityX = 2f;
    [SerializeField] float launchVelocityY = 15f;

    //state
    Vector2 paddleToBallVector;
    bool hasStarted = false;

	// Use this for initialization
	void Start ()
    {
        paddleToBallVector = transform.position - paddle1.transform.position;
	}
	
	// Update is called once per frame
	void Update ()
    {
        if (!hasStarted)
        {
            LockBallToPaddle();
            LaunchOnMouseClick();
        }
    }

    void LockBallToPaddle()
    {
        Vector2 paddlePos = new Vector2(paddle1.transform.position.x, paddle1.transform.position.y);
        transform.position = paddlePos + paddleToBallVector;
    }

    void LaunchOnMouseClick()
    {
        if (Input.GetMouseButtonUp(0))
        {
            GetComponent<Rigidbody2D>().velocity = new Vector2(launchVelocityX, launchVelocityY);
            hasStarted = true;
        }
    }
}
