﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Paddle : MonoBehaviour {

    //config parameters
    float screenWidthInUnits;
    [SerializeField] Camera mainCamera;

    float minX;
    float maxX;
    
	// Use this for initialization
	void Start ()
    {
        GetScreenWidth();
        SetPaddleBoundaries();
    }

    private void GetScreenWidth()
    {
        float resolutionFactor = (float)Screen.width / (float)Screen.height;
        float cameraSizeInUnits = mainCamera.GetComponent<Camera>().orthographicSize;
        screenWidthInUnits = 2f * cameraSizeInUnits * resolutionFactor;
    }

    private void SetPaddleBoundaries()
    {
        float paddleHalfWidth = GetComponent<Collider2D>().bounds.extents.x;
        minX = paddleHalfWidth;
        maxX = screenWidthInUnits - paddleHalfWidth;
    }

    // Update is called once per frame
    void Update () {
        float mousePosInUnits = Input.mousePosition.x * screenWidthInUnits / Screen.width;
        Vector2 paddlePos = new Vector2(transform.position.x, transform.position.y);
        paddlePos.x = Mathf.Clamp(mousePosInUnits, minX, maxX);
        transform.position = paddlePos;
	}
}
